#ifndef HJM
#define HJM

#include "Yield.h"

class Slice {
  private:
    int Nr, NV;
  public:
    Slice(int r, int V, double at);
    Slice(Slice &sl);
    ~Slice();
    double **u;
    double t;
    bool asset;
    void maxSlice(Slice &sl);
    void maxSlice(double d);
    void addSlice(double d);
};

class HJMTree {
  private:
    double end;
    
    double sigma;
    
    double right_r, left_r;
    double right_V, left_V;
    int Nr;
    int NV;
    int Nt;
    
    double dr;
    double dV;
    double dt;
    
    int pos;
    double pop;

    double upV_aux;
    double up_down_r_aux;

    double **aux;

    YieldCurve &yc;
    
    void pas(Slice &sl);
    void actualisation(Slice &sl);

  public:
    HJMTree(double e, double s, double rr, double lr, double rV, double lV, double r, double V, double t, YieldCurve &ayc);
    ~HJMTree();
    Slice getSlice(double tmp);
    void PDE(Slice &sl, double t);
    double valueAtOrigin(Slice &sl);
    void print_data();
};

#endif