#include <math.h>
#include "Yield.h"

/* courbe de taux court terme a la date 0 */
double YieldCurve::r0(double t) {
  return 0.04 + 0.006 * t;
//  return 0.06;
}

/* derivee de la courbe de taux a la date 0 */
double YieldCurve::r0t(double t) {
  return 0.006;
//  return 0;
}

/* valeur forward en t d'un ZC de maturit T  l'instant 0 */
double YieldCurve::b0f(double t, double T) {
/*  const double ddt = 0.01;
  double b = 0, dd;
  for (dd = t; dd < T; dd += ddt) {
    b += r0(dd) * ddt;
  }
  b += r0(dd) * (T - dd);

  return exp(-b);*/
  return exp(- 0.04 * (T - t) - 0.003 * (T * T - t * t));
//  return exp(- 0.06 * (T - t));
}

/* valeur d'un ZC en t de matrit T */
double YieldCurve::bond(double t, double T, double r, double V) {
  const double factor = T - t;
  return b0f(t, T) * exp(- factor * (r - r0(t) + 0.5 * factor * V));
}

/* valeur d'un swap dont le taux fixe est k */
double YieldCurve::swap(double t, double T, int n, double d, double k, double r, double V) {
  double p = bond(t, T, r, V) - bond(t, T + n * d, r, V);
  for (int i = 1; i <= n; i++) {
    p -= k * d * bond(t, T + i * d, r, V);
  }
  return p;
}

/* taux de swap */
double YieldCurve::IRS(double t, double T, int n, double d, double r, double V) {
  double p = 0;
  for (int i = 1; i <= n; i++) {
    p += bond(t, T + i * d, r, V);
  }
  return (bond(t, T, r, V) - bond(t, T + n * d, r, V)) / (d * p);
}